//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   CDROM info


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_files.h"


#define pgVERS_ "V2.10"
#define pgTITL_ "CDROM Information"
#define pgCOPR_ "1993"


#define DEBUG_  FALSE


void    vtoc( UCHAR drv )
{
    int         s ;
    unsigned    type ;
    char        v[2048] ;

    s = dr_get_cdrom_vtoc( drv, v, &type );
    printf( "VTOC for drive %c:.  status = %d, type = %04Xh\n", ((char)drv+(char)'@'), s, type );
    if ( s == 1 )
    {
        for ( s = 0; s < 128; s++ )
        {   int j;
            printf("%03d  ", s );
            for ( j = 0; j < 16; j++ )
                printf("%02X ", (UCHAR) v[(s * 16) + j] );
            printf( " " );
            for ( j = 0; j < 16; j++ )
            {
                if ( isprint(v[(s * 16) + j]) )
                    printf( "%c", v[(s * 16) + j] );
                else
                    printf( "." );
            }
            printf( "\n" );
        }
    }
}


void    main( void )
{
    BOOL   status ;
    int    ndrive, MSCDEX_v, MSCDEX_major, MSCDEX_minor ;
    UCHAR  st_drive ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    printf( "\n" );
#if DEBUG_
    printf( "Executing MSCDEX_installed()\n" );
#endif
    if ( ! MSCDEX_installed() )
    {
        printf( "MSCDEX driver is not installed\n" );
        exit( 1 );
    }
#if DEBUG_
    printf( "Executing MSCDEX_version()\n" );
#endif
    MSCDEX_v = MSCDEX_version( &MSCDEX_major, &MSCDEX_minor );
    printf( "Microsoft CDROM Extensions (MSCDEX) version %d.%02d installed\n", MSCDEX_major, MSCDEX_minor );
    if ( MSCDEX_major < 2 )
        printf( "You should upgrade to MSCDEX version 2.20 or higher\a\n" );
    printf( "\n" );

#if DEBUG_
    printf( "Executing MSCDEX_cdrom_drives()\n" );
#endif
    ndrive = MSCDEX_cdrom_drives( &st_drive );
    printf( "%d CDROM drive%s, starting with drive %c:\n", ndrive, (ndrive==1 ? "" : "s"), st_drive+'@' );

#if DEBUG_
    printf( "Looping dr_is_cdrom()\n" );
#endif
    printf( "\nTesting drives:\n" );
    for ( ndrive = 1 ; ndrive < 27 ; ndrive++ )
    {
        status = dr_is_cdrom( (UCHAR) ndrive );
        switch ( status )
        {
            case TRUE :
                printf( "\tdrive %c: is a CDROM drive\n", '@'+ndrive );
                vtoc( (UCHAR) ndrive );
                break ;
            case FALSE :
                break ;
            default :
                printf( "\t*** drive %c: is an Invalid Device [%d]\n", '@'+ndrive, status );
        }
    }
    exit( 0 );
}
