/*
   Code to demonstrate CD-ROM function calls

   This code does not do anything useful in and of itself.
   (c) Marcus W. Johnson 1994
   This code may be used freely in any application, commercial or otherwise.
*/


#include<malloc.h>  // alloc.h
#include<conio.h>
#include<ctype.h>
#include<stdio.h>


struct  driver
{
    unsigned char unit;
    void far*     device_driver_header;
};

union   position
{
    unsigned long raw;
    struct redBook
    {
        unsigned char   frame;
        unsigned char   second;
        unsigned char   minute;
        unsigned char   unused;
    }   cooked;
};

struct  audioData
{
    unsigned char   lowTrack;
    unsigned char   highTrack;
    union position  leadOutTrack;
};

struct  trackData
{
    union position  StartAddress;
    unsigned int    trackControl;
};


int far                 close_door(char far* fileName);
int far                 cd_eject_disk(char far* fileName);
int far                 get_abstract_filename(unsigned char drive, char far* buffer);
int far                 get_audio_status(char far* fileName, struct audioData far* adPtr);
int far                 get_bibliography_filename(unsigned char drive, char far* buffer);
unsigned int far        cd_get_drive_count(unsigned char far* firstDrive);
int far                 get_copyright_filename(unsigned char drive, char far* buffer);
int far                 dr_get_cdrom_status(char far* fileName, unsigned int far* status);
void far                cd_get_drive_letters(unsigned char far* array);
void far                cd_get_driver_array(struct driver far* array);
int far                 get_sector_size(char far* fileName, unsigned int far* sectorSize, unsigned char far* mode);
int far                 get_track_info(char far* fileName, unsigned char track, struct trackData far* tdPtr);
int far                 get_vtoc(unsigned char drive, unsigned char far* vtoc);
int far                 get_volume_size(char far* fileName, unsigned long far* sectorCount);
int far                 is_cdrom(unsigned char drive);
int far                 lock_door(char far* fileName);
int far                 mscdex_installed(void);
unsigned int far        mscdex_version(void);
int far                 pause_audio(unsigned int drive);
int far                 play_audio(unsigned int drive, unsigned long sector, unsigned long frameCount);
int far                 reset_drive(char far* fileName);
int far                 resume_audio(unsigned int drive);
int far                 unlock_door(char far* fileName);

unsigned char   vtoc[ 2048 ];


void    main(void)
{
    int                     status;
    unsigned int            result;
    unsigned char           result2;
    unsigned int            count;
    unsigned char           firstDrive;
    struct driver*          driverArray;
    int                     k;
    unsigned int            version;
    unsigned char*          driveLetters;
    char                    fileName[ 9 ];
    char far*               s;
    unsigned long           sectorCount;
    char                    longFileName[ 38 ];
    struct audioData        ad;
    struct trackData        td;
    unsigned long           startAddress;

    status = mscdex_installed();
    switch (status)
    {
        case    -1:
            printf("MSCDEX is installed\n");
            break;
        case    0:
            printf("MSCDEX is not installed\n");
            return;
        case    1:
            printf("MSCDEX is not installed and cannot be installed\n");
            return;
        default:
            printf("Strange value [ 0x%4.4X ] returned from mscdex_installed()\n", status);
            return;
    }
    version = mscdex_version();
    printf("MSCDEX Version %d.%2.2d\n", version >> 8, version & 0x00FF);
    count = cd_get_drive_count(&firstDrive);
    printf("There %s %u CD-ROM drive%s; %s is drive %c\n",
           count == 1 ? "is" : "are", count, count == 1 ? "" : "s",
           count == 1 ? "it" : "the first", firstDrive);

    driverArray = malloc(count * sizeof(struct driver));
    cd_get_driver_array(driverArray);
    for (k = 0; k < count; k++)
    {
        printf("Drive %d is unit %d of device driver %Fp\n", k, driverArray[ k ].unit, driverArray[ k ].device_driver_header);
    }
    s = (char far*)driverArray[ 0 ].device_driver_header;
    for (k = 0; k < 8; k++)
    {
        if (s[ 10 + k ] == ' ')
        {
            break;
        }
        fileName[ k ] = s[ 10 + k ];
    }
    fileName[ k ] = 0;
    free(driverArray);
    printf("Drive 1 Device name = [%s]\n", fileName);

    driveLetters = malloc(count * sizeof(unsigned char));
    cd_get_drive_letters(driveLetters);
    for (k = 0; k < count; k++)
    {
        printf("Drive %c is a CD-ROM drive\n", driveLetters[ k ] + 'A');
    }
    free(driveLetters);

    for (k = 0; k < 26; k++)
    {
        printf("Drive %c is%s a CD-ROM drive\n", k + 'A', is_cdrom(k) ? "" : " not");
    }
    printf("Eject disk status = %X\n", cd_eject_disk(fileName));
    printf("Press a key to close the door\n");
    getch();
    printf("Close door status = %X\n", close_door(fileName));
    printf("Lock door status = %X\n", lock_door(fileName));
    printf("Try to open the door; press a key to unlock the door\n");
    getch();
    printf("Unlock door status = %X\n", unlock_door(fileName));
    printf("Reset drive status = %X\n", reset_drive(fileName));
    printf("Get device status = %X\n", dr_get_cdrom_status(fileName, &result));
    if (result & 0x0400)
    {
        printf("Audio is playing\n");
    }
    if (result & 0x0200)
    {
        printf("Red book and HSG addressing both supported\n");
    }
    if (result & 0x0100)
    {
        printf("Audio channel control supported\n");
    }
    if (result & 0x0080)
    {
        printf("Prefetch requests supported\n");
    }
    if (result & 0x0020)
    {
        printf("Interleaving supported\n");
    }
    if (result & 0x0010)
    {
        printf("Audio/video track playback supported\n");
    }
    if (result & 0x0008)
    {
        printf("Disk is writable\n");
    }
    if (result & 0x0004)
    {
        printf("Raw and cooked read supported\n");
    }
    if (result & 0x0002)
    {
        printf("Door is unlocked\n");
    }
    if (result & 0x0001)
    {
        printf("Door is open\n");
    }
    printf("Insert a data disk in the tray\n");
    if ((result & 0x0001) == 0)
    {
        cd_eject_disk(fileName);
        printf("Press a key when the disk is in the tray\n");
        getch();
    }
    close_door(fileName);
    lock_door(fileName);
    reset_drive(fileName);
    printf("get_sector_size() reports status %x\n", get_sector_size(fileName, &result, &result2));
    printf("\tSector size is %u bytes; mode is %s\n", result, result2 == 1 ? "raw" : (result2 == 0 ? "cooked" : "unknown"));

    reset_drive(fileName);
    printf("Volume size status %X\n", get_volume_size(fileName, &sectorCount));
    printf("\tVolume size is %lu sectors\n", sectorCount);
    reset_drive(fileName);
    get_abstract_filename(firstDrive - 'A', longFileName);
    printf("Abstract filename is [%s]\n", longFileName);
    reset_drive(fileName);
    get_bibliography_filename(firstDrive - 'A', longFileName);
    printf("Bibliography filename is [%s]\n", longFileName);
    reset_drive(fileName);
    get_copyright_filename(firstDrive - 'A', longFileName);
    printf("Copyright filename is [%s]\n", longFileName);
    reset_drive(fileName);
    get_vtoc(firstDrive - 'A', vtoc);
    for (k = 0; k < 128; k++)
    {
        int     j;

        printf("%3.3d ", k);
        for (j = 0; j < 16; j++)
        {
            printf("%2.2X ", vtoc[ (k * 16) + j ]);
        }
        for (j = 0; j < 16; j++)
        {
            if (isprint(vtoc[ (k * 16) + j ]))
            {
                printf("%c", vtoc[ (k * 16) + j ]);
            }
            else
            {
                printf(".");
            }
        }
        printf("\n");
    }
    printf("Insert an audio disk in the tray\n");
    unlock_door(fileName);
    cd_eject_disk(fileName);
    printf("Press a key when the disk is in the tray\n");
    getch();
    close_door(fileName);
    lock_door(fileName);
    reset_drive(fileName);
    printf("%X returned from get_audio_status\n", get_audio_status(fileName, &ad));
    printf("\tLow track = %u\n", ad.lowTrack);
    printf("\tHigh track = %u\n", ad.highTrack);
    printf("\tLead-out track = %u:%2.2u:%2.2u\n", ad.leadOutTrack.cooked.minute, ad.leadOutTrack.cooked.second, ad.leadOutTrack.cooked.frame);

    for (k = ad.lowTrack; k <= ad.highTrack; k++)
    {
        get_track_info(fileName, k, &td);
        printf("\tTrack %2d %2d:%2.2d:%2.2d", k, td.StartAddress.cooked.minute, td.StartAddress.cooked.second, td.StartAddress.cooked.frame);

        switch (td.trackControl & 0xF000)
        {
            case 0x0000:
                printf(" 2 channels, no pre-emphasis\n");
                break;
            case 0x1000:
                printf(" 2 channels,    pre-emphasis\n");
                break;
            case 0x2000:
                printf(" 2 channels, no pre-emphasis, copy OK\n");
                break;
            case 0x3000:
                printf(" 2 channels,    pre-emphasis, copy OK\n");
                break;
            case 0x4000:
                printf(" Data track\n");
                break;
            case 0x5000:
                printf(" ???\n");
                break;
            case 0x6000:
                printf(" Data track,                  copy OK\n");
                break;
            case 0x7000:
                printf(" ???\n");
                break;
            case 0x8000:
                printf(" 4 channels, no pre-emphasis\n");
                break;
            case 0x9000:
                printf(" 4 channels,    pre-emphasis\n");
                break;
            case 0xA000:
                printf(" 4 channels, no pre-emphasis, copy OK\n");
                break;
            case 0xB000:
                printf(" 4 channels,    pre-emphasis, copy OK\n");
                break;
            case 0xC000:
                printf(" ???\n");
                break;
            case 0xD000:
                printf(" ???\n");
                break;
            case 0xE000:
                printf(" ???\n");
                break;
            case 0xF000:
                printf(" ???\n");
                break;
        }
    }
    get_track_info(fileName, ad.lowTrack, &td);
    startAddress = (unsigned long) td.StartAddress.cooked.minute;
    startAddress *= 60;
    startAddress += (unsigned long) td.StartAddress.cooked.second;
    startAddress *= 75;
    startAddress += (unsigned long) td.StartAddress.cooked.frame;
    startAddress -= 150;
    reset_drive(fileName);
    printf("Volume size status %X\n", get_volume_size(fileName, &sectorCount));
    reset_drive(fileName);
    printf("Play audio status = 0x%4.4X\n", play_audio(firstDrive - 'A', startAddress, sectorCount));
    printf("Press any key to pause\n");
    getch();
    printf("Pause audio status = 0x%4.4X\n", pause_audio(firstDrive - 'A'));
    printf("Press any key to resume\n");
    getch();
    printf("Resume audio status = 0x%4.4X\n", resume_audio(firstDrive - 'A') );
    unlock_door(fileName);
    exit(0);
}
