.MODEL LARGE,C

.CODE

close_door              PROTO   FileName:DWORD
cd_eject_disk           PROTO   FileName:DWORD
get_abstract_filename   PROTO   Drive:WORD,Buffer:DWORD
get_audio_status        PROTO   FileName:DWORD,DataBlock:DWORD
get_bibliography_filename       PROTO   Drive:WORD,Buffer:DWORD
cd_get_drive_count      PROTO   FirstDrive:DWORD
get_copyright_filename  PROTO   Drive:WORD,Buffer:DWORD
dr_get_cdrom_status     PROTO   FileName:DWORD,Status:DWORD
cd_get_drive_letters    PROTO   LetterArray:DWORD
cd_get_driver_array     PROTO   DriverArray:DWORD
get_sector_size         PROTO   FileName:DWORD,SectorSize:DWORD,Mode:DWORD
get_track_info          PROTO   FileName:DWORD,Track:WORD,DataBlock:DWORD
get_volume_size         PROTO   FileName:DWORD,SectorCount:DWORD
get_vtoc                PROTO   Drive:WORD,Buffer:DWORD
is_cdrom                PROTO   Drive:WORD
lock_door               PROTO   FileName:DWORD
mscdex_installed        PROTO
mscdex_version          PROTO
pause_audio             PROTO   Drive:WORD
play_audio              PROTO   Drive:WORD,Sector:DWORD,FrameCount:DWORD
reset_drive             PROTO   FileName:DWORD
resume_audio            PROTO   Drive:WORD
unlock_door             PROTO   FileName:DWORD
;
; close the door
;
close_door      PROC    USES BX CX DX DS        FileName:DWORD

        LOCAL   Command:BYTE
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Command,5
                mov     CX,1
                lea     DX,Command
                push    SS
                pop     DS
                mov     AX,4403H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

close_door      ENDP

; eject the current CD
;
cd_eject_disk   PROC    USES BX CX DX DS        FileName:DWORD
        LOCAL   Command:BYTE
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Command,0
                mov     CX,1
                lea     DX,Command
                push    SS
                pop     DS
                mov     AX,4403H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret
cd_eject_disk   ENDP

; get name of the file containing the CD-ROM abstract
;
get_abstract_filename   PROC    USES BX CX ES   Drive:WORD,Buffer:DWORD

        les     BX,Buffer
        mov     CX,Drive
        xor     CH,CH
        mov     AX,1503H
        int     2FH
        .IF !CARRY?
                xor     AX,AX
        .ENDIF
        ret

get_abstract_filename   ENDP

audioData       STRUCT

        Command         BYTE    ?
        lowTrack        BYTE    ?
        highTrack       BYTE    ?
        leadOutTrack    DWORD   ?

audioData       ENDS

;
; get audio status
;
get_audio_status        PROC    USES BX CX DX DI SI DS ES       FileName:DWORD,DataBlock:DWORD

        LOCAL   Buffer:audioData
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,0AH
                mov     CX,7
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4402H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                        les     DI,DataBlock
                        lea     SI,Buffer.lowTrack
                        push    SS
                        pop     ES
                        mov     CX,3
                        cld
                rep     movsw
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

get_audio_status        ENDP
;
; get name of the file containing the CD-ROM bibliography
;
get_bibliography_filename       PROC    USES BX CX ES   Drive:WORD,Buffer:DWORD

        les     BX,Buffer
        mov     CX,Drive
        xor     CH,CH
        mov     AX,1504H
        int     2FH
        .IF !CARRY?
                xor     AX,AX
        .ENDIF
        ret

get_bibliography_filename       ENDP

; how many CD-ROM drives are there, and to which drive letter is the
; first one assigned?
;
cd_get_drive_count PROC USES BX CX ES   FirstDrive:DWORD
        mov     AX,1500H
        xor     BX,BX
        int     2FH
        mov     AX,BX
        add     CL,'A'
        les     BX,FirstDrive
        mov     ES:[BX],CL
        ret
cd_get_drive_count ENDP

; get name of the file containing the CD-ROM copyright
;
get_copyright_filename  PROC    USES BX CX ES   Drive:WORD,Buffer:DWORD

        les     BX,Buffer
        mov     CX,Drive
        xor     CH,CH
        mov     AX,1502H
        int     2FH
        .IF !CARRY?
                xor     AX,AX
        .ENDIF
        ret

get_copyright_filename  ENDP


deviceStatus    STRUCT
        Command BYTE    ?
        Result  DWORD   ?
deviceStatus    ENDS

; get device status
;
dr_get_cdrom_status     PROC    USES BX CX DX DS        FileName:DWORD,Status:DWORD

        LOCAL   Buffer:deviceStatus
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,6
                mov     CX,5
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4402H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                        lds     BX,Status
                        mov     DX,WORD PTR Buffer.Result
                        mov     DS:[BX],DX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

dr_get_cdrom_status     ENDP

; get the list of CD-ROM drive letters
;
cd_get_drive_letters    PROC    USES BX ES      LetterArray:DWORD

        mov     AX,150DH
        les     BX,LetterArray
        int     2FH
        ret

cd_get_drive_letters    ENDP

; get the list of CD-ROM devices and their driver/unit numbers
;
cd_get_driver_array     PROC    USES BX ES      DriverArray:DWORD

        mov     AX,1501H
        les     BX,DriverArray
        int     2FH
        ret

cd_get_driver_array     ENDP

_SectorSize     STRUCT

        Command         BYTE    ?
        ReportMode      BYTE    ?
        ReportSize      WORD    ?

_SectorSize     ENDS

;
; get sector size
;
get_sector_size PROC    USES BX CX DX DS        FileName:DWORD,SectorSize:DWORD,Mode:DWORD

        LOCAL   Buffer:_SectorSize
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,7
                mov     CX,4
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4402H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                        lds     BX,SectorSize
                        mov     DX,Buffer.ReportSize
                        mov     DS:[BX],DX
                        lds     BX,Mode
                        mov     DL,Buffer.ReportMode
                        mov     DS:[BX],DL
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

get_sector_size ENDP


trackData       STRUCT

        Command         BYTE    ?
        TrackNumber     BYTE    ?
        StartAddress    DWORD   ?
        TrackControl    WORD    ?

trackData       ENDS

;
; get track address and control data
;
get_track_info  PROC    USES BX CX DX DI SI DS ES       FileName:DWORD,Track:WORD,DataBlock:DWORD

        LOCAL   Buffer:trackData
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,0BH
                mov     AX,Track
                mov     Buffer.TrackNumber,AL
                mov     CX,8
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4402H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                        les     DI,DataBlock
                        lea     SI,Buffer.StartAddress
                        push    SS
                        pop     ES
                        mov     CX,3
                        cld
                rep     movsw
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

get_track_info  ENDP

volume  STRUCT

        Command BYTE    ?
        Sectors DWORD   ?

volume  ENDS

;
; get volume size in sectors
;
get_volume_size PROC    USES BX CX DX DS        FileName:DWORD,SectorCount:DWORD

        LOCAL   Buffer:Volume
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,8
                mov     CX,5
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4402H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                        lds     BX,SectorCount
                        mov     DX,WORD PTR Buffer.Sectors
                        mov     DS:[BX],DX
                        mov     DX,WORD PTR Buffer.Sectors+2
                        mov     DS:[BX+2],DX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

get_volume_size ENDP
;
; get volume table of contents
;
get_vtoc        PROC    USES BX CX DX ES        Drive:WORD,Buffer:DWORD

        les     BX,Buffer
        mov     CX,Drive
        xor     CH,CH
        xor     DX,DX
        mov     AX,1505H
        int     2FH
        ret

get_vtoc        ENDP
;
; is the specified drive a CD-ROM?
;
is_cdrom        PROC    USES BX CX      Drive:WORD

        mov     AX,150BH
        mov     CX,Drive
        int     2FH
        .IF AX != 0
                .IF BX == 0ADADH
                        mov     AX,1
                .ELSE
                        xor     AX,AX
                .ENDIF
        .ENDIF
        ret

is_cdrom        ENDP
;
doorlock        STRUCT

        Command         BYTE    ?
        SubCommand      BYTE    ?

doorlock        ENDS
;
; lock the door
;
lock_door       PROC    USES BX CX DX DS        FileName:DWORD

        LOCAL   Buffer: doorlock
        LOCAL   Handle: WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,1
                mov     Buffer.SubCommand,1
                mov     CX,2
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4403H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

lock_door       ENDP
;
; Are MSCDEX CD-ROM Extensions installed?
;
; returns 0 if not, 1 if not and cannot be, -1 if installed
;
mscdex_installed        PROC    USES BX

        mov     AX,0DADAH
        push    AX
        mov     AX,01100H
        int     2FH
        pop     BX
        .IF BX != 0ADADH
                xor     AL,AL
        .ENDIF
        cbw
        ret

mscdex_installed        ENDP
;
; return the MSCDEX version
;
mscdex_version  PROC    USES BX

        mov     AX,150CH
        int     2FH
        mov     AX,BX
        ret

mscdex_version  ENDP

PauseHeader     STRUCT

        HeaderLength    BYTE    ?
        UnitNumber      BYTE    ?
        Function        BYTE    ?
        Status          WORD    ?
                        DWORD   ?
                        DWORD   ?

PauseHeader     ENDS

;
; pause audio
;
pause_audio     PROC    USES BX CX ES   Drive:WORD

        LOCAL   Buffer:PauseHeader

        mov     Buffer.HeaderLength,13
        mov     Buffer.UnitNumber,0
        mov     Buffer.Function,85H
        lea     BX,Buffer
        push    SS
        pop     ES
        mov     CX,Drive
        mov     AX,1510H
        int     2FH
        mov     AX,Buffer.Status
        ret

pause_audio     ENDP

PlayHeader      STRUCT

        HeaderLength    BYTE    ?
        UnitNumber      BYTE    ?
        Function        BYTE    ?
        Status          WORD    ?
                        DWORD   ?
                        DWORD   ?
        Addressing      BYTE    ?
        StartSector     DWORD   ?
        SectorCount     DWORD   ?

PlayHeader      ENDS

;
; play audio
;
play_audio      PROC    USES BX CX ES   Drive:WORD,Sector:DWORD,FrameCount:DWORD

        LOCAL   Buffer:PlayHeader

        mov     Buffer.HeaderLength,22
        mov     Buffer.UnitNumber,0
        mov     Buffer.Function,84H
        mov     Buffer.Addressing,0     ; HSG addressing
        mov     AX,WORD PTR Sector
        mov     WORD PTR Buffer.StartSector,AX
        mov     AX,WORD PTR Sector+2
        mov     WORD PTR Buffer.StartSector+2,AX
        mov     AX,WORD PTR FrameCount
        mov     WORD PTR Buffer.SectorCount,AX
        mov     AX,WORD PTR FrameCount+2
        mov     WORD PTR Buffer.SectorCount+2,AX
        lea     BX,Buffer
        push    SS
        pop     ES
        mov     CX,Drive
        mov     AX,1510H
        int     2FH
        mov     AX,Buffer.Status
        ret

play_audio      ENDP
;
; reset the drive
;
reset_drive     PROC    USES BX CX DX DS        FileName:DWORD

        LOCAL   Command:BYTE
        LOCAL   Handle:WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Command,2
                mov     CX,1
                lea     DX,Command
                push    SS
                pop     DS
                mov     AX,4403H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

reset_drive     ENDP

ResumeHeader    STRUCT

        HeaderLength    BYTE    ?
        UnitNumber      BYTE    ?
        Function        BYTE    ?
        Status          WORD    ?
                        DWORD   ?
                        DWORD   ?

ResumeHeader    ENDS

;
; resume audio
;
resume_audio    PROC    USES BX CX ES   Drive:WORD

        LOCAL   Buffer:ResumeHeader

        mov     Buffer.HeaderLength,13
        mov     Buffer.UnitNumber,0
        mov     Buffer.Function,88H
        lea     BX,Buffer
        push    SS
        pop     ES
        mov     CX,Drive
        mov     AX,1510H
        int     2FH
        mov     AX,Buffer.Status
        ret

resume_audio    ENDP
;
; unlock the pod door, HAL
;
unlock_door     PROC    USES BX CX DX DS        FileName:DWORD

        LOCAL   Buffer: doorlock
        LOCAL   Handle: WORD

        lds     DX,FileName
        mov     AX,3D02H
        int     21H
        .IF !CARRY?
                mov     BX,AX
                mov     Handle,BX
                mov     Buffer.Command,1
                mov     Buffer.SubCommand,0
                mov     CX,2
                lea     DX,Buffer
                push    SS
                pop     DS
                mov     AX,4403H
                int     21H
                .IF !CARRY?
                        xor     AX,AX
                .ENDIF
                push    AX
                mov     BX,Handle
                mov     AH,3EH
                int     21H
                pop     AX
        .ENDIF
        ret

unlock_door     ENDP

END
